<template>
    <div class="chat">
        <div class="video-container">
            <video class="my-video" ref="myVideo" id="myVideo" autoplay></video>
            <video class="user-video" ref="userVideo" id="userVideo" autoplay></video>


        </div>
        <div>
            <button @click="callTo(receiver.id)">call</button>
            <button @click="cancle">cancle</button>
        </div>
    </div>
</template>

<script>
    import Pusher from 'pusher-js';
    import Peer from 'simple-peer';
    const APP_KEY='a98dc9b6ff7c0653405f';
    export default{
        myVideo : document.getElementById('myVideo'),
        userVideo : document.getElementById('userVideo'),
        constructor() {
            this.user = window.user;
            this.peers = {};
            this.user.stream=null;
            //this.mediaHandeler = new MediaHandler();

        },
        props:{
            user:{
                type:Object,
                required:true,
            },
            receiver:{
                type:Object,
                required:true,
            }
        },
        data(){
            return {
                hasMedia: false,
                otherUserId: null,
                peers:{},
                online:[]
            }
        },
        mounted() {
            this.myVideo = this.$refs.myVideo;
            this.getPermission()
                .then((stream)=>{
                    this.hasMedia=true;
                    this.user.stream=stream;
                    try{
                        this.myVideo.srcObject=stream;
                    }catch (e) {
                        this.myVideo.src = window.URL.createObjectURL(stream);
                    }
                    this.myVideo.play();
                });
            this.setupPusher();
            this.callTo = this.callTo.bind(this);
            this.setupPusher = this.setupPusher.bind(this);
            this.startPeer = this.startPeer.bind(this);
        },
        created() {
            this.callTo(this.receiver.id);
        },
        methods:{
            getPermission(){
                return new Promise((resolve, reject) => {
                    navigator.mediaDevices.getUserMedia({video:true,audio:true})
                        .then((stream)=>{
                            resolve(stream);
                        })
                        .catch(err=>{
                            throw new Error(`Unable to fetch stream ${err}`);
                        })
                });
            },
            setupPusher(){
                this.pusher= new Pusher(APP_KEY,{
                    authEndpoint: '/pusher/auth',
                    cluster:'ap2',
                    auth:{
                        params: this.user.id,
                        headers:{
                            'X-CSRF-Token': window.csrfToken
                        }
                    }
                });
                this.channel = this.pusher.subscribe('presence-video-channel');
                //this.online.push(this.user);
                this.channel.bind(`client-signal-${this.user.id}`,(signal)=>{
                    let peer = this.peers[signal.userId];
                    // if peer is not already exists, we got an incoming call
                    if(peer === undefined) {
                        this.otherUserId=signal.userId;
                        peer = this.startPeer(signal.userId, false);
                    }
                    peer.signal(signal.data);
                });
            },
            startPeer(userId, initiator=true){
                const peer = new Peer({
                    initiator,
                    stream:this.user.stream,
                    trickle:false,
                });
                peer.on('signal',(data)=>{
                    this.channel.trigger(`client-signal-${userId}`,{
                        type:'signal',
                        userId:this.user.id,
                        data:data,
                    });
                    //console.log(data);
                });
                this.userVideo = this.$refs.userVideo;
                peer.on('stream', (stream) => {
                    try {
                        this.userVideo.srcObject = stream;
                    } catch (e) {
                        this.userVideo.src = window.URL.createObjectURL(stream);
                    }

                    this.userVideo.play();
                });

                peer.on('close', () => {
                    let peer = this.peers[userId];
                    if(peer !== undefined) {
                        peer.destroy();
                    }

                    this.peers[userId] = undefined;
                });
                return peer;
            },
            callTo(userId) {
                this.peers[userId] = this.startPeer(userId);
                console.log(this.peers[userId]);
            },
            cancle(){
                window.close()
            }
        }
    }
</script>
